﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;

namespace SwearFilter
{
    class Program
    {
        static void Main()
        {
            Program program = new Program();

            program.TestSwearFilter("This message contains the word boobs");
            program.TestSwearFilter("I think THATCHER is the most disgusting word in the English language");
            program.TestSwearFilter("The code should !#willy%%^ ignore punctiation");
            program.TestSwearFilter("This message is lovely, like hugging a puppy");

            Console.ReadLine();
        }



        // List to store swear words.
        List<string> swearwords = new List<string>();

        Program()
        {
            LoadSwearWords();
        }

        void LoadSwearWords()
        {
            // Get the path to the 'swear.txt' file.
            string file = Path.Combine(Environment.CurrentDirectory, "swear.txt");

            // Open text file for reading.
            using (TextReader reader = new StreamReader(file))
            {
                // Loop through each line in the file.
                string line;
                while ((line = reader.ReadLine()) != null)
                {
                    // Remove any whitespace and cast to lower case.
                    string word = line.Trim().ToLower();

                    // Add to list in memory.
                    this.swearwords.Add(word);
                }
            }
        }

        bool MessageContainsSwearWord(string message)
        {
            // This regex splits words, trims whitespace and removes punctuation.
            string[] words = Regex.Split(message, @"\W+");

            // Loop through each word and check if it's a swear word.
            foreach (string word in words)
            {
                if (this.swearwords.Contains(word.ToLower()))
                {
                    return true;
                }
            }
            return false;
        }

        void TestSwearFilter(string message)
        {
            if (MessageContainsSwearWord(message))
            {
                Console.WriteLine("That message is filthy!");
            }
            else
            {
                Console.WriteLine("Aww, what a well-spoken boy.");
            }
        }
    }
}
